/**
 * @file main.c
 * Exemplos de operacoes bit a bit em C
 * 
 * @author Wu Shin Ting
 * @date 22 de agosto de 2020
 */

/**
 * @brief programa-demo de operacoes bit a bit
 */
int main(void)
{
	// declarar as variaveis
	int counter = 0;
	
	char a = 0b10101100;      //0b = binarios
	char b = 0b00011111;
	char c, d, e, f, g, gg, ggg, h, hh, i, ii, j, k, kk, l, ll;
	signed char m, mm, n, nn;
	
	// Bloco 1: operacoes logicas bit a bit
	c = a & b;      // AND
	d = a | b;      // OR
	e = a ^ b;      // XOR
	f = ~a;         // NOT
	
	// Bloco 2: operacoes de deslocamento
	g = 1 << 5;     // deslocamento para esquerda
	gg = f >> 5;    // deslocamento para direito
	
	// Bloco 3: aplicacoes de operacoes logicas bit a bit 
	// construcao de uma mascara de 3 bits
	ggg = 7 << 5;
	
	// manipulacao de um campo de bits de uma variavel
	// mascara de bits para 1
	j = a | ((char)(1<<4));
	// mascara de bits para 0;
	k = ~((char)(7<<3));   // contrucao da mascara
	kk = b & k;
	//mascara de bits com 0 e 1
	l = a | ((char)(0b101<<4)); // setar 1s
	ll = l & (char)(0b11011111);  // limpar 0s
	
	// operacoes em potencia de 2
	h = 50;
	hh = 50 << 2;
	i = 154;
	ii = 154 >> 1;
	
	// no deslocamento para esquerda de um tipo de dado com sinal
	// o bit inserido e 1, se negativo;  senao e 0
	m = 60;
	mm = 60  >> 1;
	n = -102;
	nn = -102 >> 1;
	
	for(;;) {
		counter++;
	}
	
	return 0;
}
